<?php
require_once (dirname(__FILE__)."/API.php");
error_reporting(E_ALL);
ini_set('display_errors', 1);
 
class LPR extends API{
    // the request of each call
    private $_request = array();

    public function __construct(){

        // call the super constructur
        $this->_request = parent::__construct();

        // process the incoming request
        $func = $this->_request->method;
        unset($this->_request->method);
        $this->$func();
    }

    // ---------------------------------------------------------------- //
    // ----------------- Process Image -------------------------------- //
    // ---------------------------------------------------------------- //
    public function processImage(){

        // validate request
        $HTTP_PUBLIC_KEY = $_SERVER['HTTP_PUBLIC_KEY'];

        //$this->validatePublicKey($_SERVER['HTTP_PUBLIC_KEY']);

        // define the output image name
        $image_name = dirname(__FILE__) . '/temp/temp_' . rand() . '.jpg';

        // handle image as multipart form
        if(array_key_exists('image',$_FILES)){
            $url = $_FILES['image']['tmp_name'];
            file_put_contents($image_name, file_get_contents($url));
        }
        // handle image as remote url
        else if($this->_request->image){
            $url = $this->_request->image;
            file_put_contents($image_name, file_get_contents($url));
        }
        // handle image as base 64
        else if($this->_request->image_64){
            $base64_string = $this->_request->image_64;
            $data = explode(',', $base64_string);
            $content = base64_decode($data[1]);
            $file = fopen($image_name, "wb");
            fwrite($file, $content);
            fclose($file);
            $url = "1";
        }

        if(!$url){
            echo "INVALID IMAGE";die;
        }

        $ch = curl_init();
        $data = array('regions' => 'jo', 'upload' => new CURLFile( $image_name ));

        curl_setopt($ch, CURLOPT_URL, 'https://api.platerecognizer.com/v1/plate-reader');
        curl_setopt($ch, CURLOPT_POST, 1);   
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
            'Authorization: token 65a3644fb0af41543b8de2f6d92bf4c6f493e4e9'
        ));

        $result = curl_exec($ch);       

        // delete the image
        unlink($image_name);

        // return result
        echo($result);
    }


    private function validatePublicKey($key){
        switch ($key) {
            //RIDE APP
            case 'cq3nCQyAq2HzqJG9bezZXPNTY3vpdLQk8CZGXd3vsCmXWGg8Xtu8NzUarNyvrcqE':
                return true;
                break;
            
            default:
                echo("INVALID TOKEN");
                die;
                break;
        }
    }


}

new LPR();